<master>
<property name="doc(title)">@page_title;literal@</property>
<property name="main_navbar_label">timesheet2_timesheet</property>
<property name="left_navbar">@left_navbar_html;literal@</property>


<div id=@task_editor_id@>
<script type='text/javascript' <if @::__csp_nonce@ not nil>nonce="@::__csp_nonce;literal@"</if>>


// Ext.Loader.setConfig({enabled: true});
Ext.Loader.setPath('PO', '/sencha-core');
Ext.Loader.setPath('PO.model', '/sencha-core/model');
Ext.Loader.setPath('PO.store', '/sencha-core/store');
Ext.Loader.setPath('PO.class', '/sencha-core/class');
Ext.Loader.setPath('Ext.ux', '/sencha-core/ux');
Ext.Loader.setPath('PO.view', '/sencha-core/view');
Ext.Loader.setPath('PO.controller', '/sencha-core/controller');

Ext.require([
    'Ext.data.*',
    'Ext.grid.*',
    'Ext.tree.*',
    'PO.Utilities',
    'PO.store.CategoryStore',
    'PO.store.project.ProjectMainStore',
    'PO.controller.StoreLoadCoordinator',
    'PO.model.timesheet.TimesheetTask',
    'PO.model.timesheet.Hour',
    'PO.model.project.Project',
    'PO.store.timesheet.HourStore',
    'PO.store.timesheet.TaskTreeStore',
    'PO.view.field.POComboTree'
]);

// Global parameters from server-side
var default_material_id = parseInt('@default_material_id@');			// "Default" material
var default_cost_center_id = parseInt('@default_cost_center_id@');		// "The Company" cost-center
var default_uom_id = parseInt('@default_uom_id@');				// "Hour" default Unit of Measure
var default_effort_driven_type_id = parseInt('@default_effort_driven_type_id@'); // "Fixed Effort" as default


function launchTimesheetWeeklyLogging(){

    // -----------------------------------------------------------------------
    // Stores
    var hourStore = Ext.StoreManager.get('hourStore');
    var taskTreeStore = Ext.StoreManager.get('taskTreeStore');
    var projectStore = Ext.StoreManager.get('projectMainStore');

    // Row-Editor for the hour grid
    var rowEditing = Ext.create('Ext.grid.plugin.RowEditing', {
        clicksToMoveEditor: 2,
        listeners: {
            edit: function(editor, context, eOpts) {
                // Check that the endTime is later than startTime
                context.record.save();
            }
        }
    });

    var hourGrid = Ext.create('Ext.grid.Panel', {
        store: hourStore,
        layout: 'fit',
        region: 'center',
        columnLines: true,
        enableLocking: true,
        collapsible: false,
        title: 'Expander Rows in a Collapsible Grid with lockable columns',
        header: false,
        emptyText: 'No data yet - please click on one of the tasks at the left',
        iconCls: 'icon-grid',
        margin: '0 0 20 0',
        plugins: [rowEditing],

        // reference to controller
        hourController: null,		// Reference to main controller
        columns: [
            {
                text: 'Project',
                flex: 1,
                dataIndex: 'main_project_id',
                renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                    var main_project_id = record.get('main_project_id');
                    var projectModel = projectStore.getById(main_project_id);
                    if (!projectModel) return "";
                    return projectModel.get('project_name');
                },
                editor: {
                    xtype: 'combo',
                    queryMode:
                    'local',
                    store: projectStore,
                    displayField: 'project_name',
                    valueField: 'project_id',
                    matchFieldWidth: false,
                    listeners: {
                	change: function(combo, value, oldValue, event) {
                	    // ToDo: Replace this hard-wired reference with something more intelligent
                	    var controller = hourGrid.hourController;
                	    controller.onProjectChanged(value, combo, hourGrid);
                	}
                    }
                }
            }, {
                text: 'Task',
                flex: 1,
                dataIndex: 'project_id',
                renderer: function(task_id) {
                    var taskModel = taskTreeStore.getById(task_id);
                    if (!taskModel) return "";
                    return taskModel.get('project_name');
                },
                editor: { xtype: 'pocombotree', store: taskTreeStore, queryMode: 'local', displayField: 'project_name', valueField: 'id'}
            },
	    // { text: "Date", xtype: 'datecolumn', dataIndex: 'day', renderer: Ext.util.Format.dateRenderer('Y-m-d'), editor: {xtype: 'datefield',allowBlank: true}},
	    { text: "Mon", width: 50, dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0 }},
	    { text: "Tue", width: 50, dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0 }},
	    { text: "Wed", width: 50, dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0 }},
	    { text: "Thu", width: 50, dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0 }},
	    { text: "Fri", width: 50, dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0 }},
	    { text: "Sat", width: 50, dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0 }},
	    { text: "Sun", width: 50, dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0 }},
	    // { text: "Note", flex: 1, dataIndex: 'note', editor: { allowBlank: true }}
	]
    });

    // -----------------------------------------------------------------------
    // Outer panel joining the two parts (Buttons + Grid)
    var screenSize = Ext.getBody().getViewSize();    // Size calculation based on specific ]po[ layout
    var sideBarSize = Ext.get('sidebar').getSize();
    var width = screenSize.width - sideBarSize.width - 95;
    var height = screenSize.height - 280;

    Ext.define('PO.view.timesheet.HourWeeklyButtonPanel', {
        extend: 'Ext.panel.Panel',
        alias: 'ganttButtonPanel',
        width: 900,
        height: 500,
        layout: 'border',
        defaults: {
            collapsible: true,
            split: true,
            bodyPadding: 0
        },
        tbar: [
            {
                icon: '/intranet/images/navbar_default/add.png',
                tooltip: '<%= [lang::message::lookup "" intranet-timesheet2-weekly.Manual_logging "Manual logging"] %>',
                id: 'buttonAddEntry',
                disabled: false
            }, {
                icon: '/intranet/images/navbar_default/delete.png',
                tooltip: '<%= [lang::message::lookup "" intranet-timesheet2-weekly.Delete_logging "Delete entry"] %>',
                id: 'buttonDeleteEntry',
                disabled: false
            }, {
		xtype: 'tbseparator'
	    }, {
		xtype: 'datefield',
		// anchor: '100%',
		// fieldLabel: 'From',
		name: 'from_date',
		value: new Date(),
		maxValue: new Date(),
		format: "Y-W"
	    }
        ]
    });

    // Use the button panel as a container for the task tree and the hour grid
    var hourButtonPanel = Ext.create('PO.view.timesheet.HourWeeklyButtonPanel', {
        renderTo: '@task_editor_id@',
        width: width,
        height: height,
        resizable: true,					// Add handles to the panel, so the user can change size
        items: [
            hourGrid
        ]
    });

    // -----------------------------------------------------------------------
    // Controller
    //
    Ext.define('PO.controller.timesheet.HourWeeklyController', {
        extend: 'Ext.app.Controller',
        id: 'hourWeeklyController',
        
        // Parameters
        debug: true,
        hourButtonPanel: null,
        hourController: null,
        hourGrid: null,

        // Setup the various listeners to receive events here
        init: function() {
            var me = this;
            if (me.debug) { console.log('PO.controller.timesheet.HourWeeklyController: init'); }

            this.control({
                '#buttonAddEntry': { click: this.onButtonAddEntry },
                '#buttonDeleteEntry': { click: this.onButtonDeleteEntry },
                scope: me
            });

            // Listen to the Grid Editor that allows to specify start- and end time
            me.hourGrid.on('edit', this.onGridEdit, me);
            me.hourGrid.on('beforeedit', this.onGridBeforeEdit, me);

            // Trying to crate a "change" event from the Project combo,
            // but this didn't work. Now just hard-wiring...
            var rowEditing = me.hourGrid.editingPlugin;

            // Catch a global key strokes. This is used to abort entry with Esc.
            // For some reaons this doesn't work on the level of the HourButtonPanel, so we go for the global "window"
            Ext.EventManager.on(window, 'keydown', this.onWindowKeyDown, me);

            return this;
        },

        /**
         * The value of the Project field has changed in the RowEditing.
         */
        onProjectChanged: function(projectId, combo, hourGrid) {
            // Load taskTreeStore with new parameter
            taskTreeStore.getProxy().extraParams = { project_id: projectId };
            taskTreeStore.reload({
                callback: function(records, operation, success) {
                    var me = this;
                    if (hourGrid.debug) console.log('PO.store.timesheet.TaskTreeStore: loaded');
                    if (!success) {
                	PO.Utilities.reportStoreError("TaskTreeStore", operation);
                	return;
                    }
                    var mainProjectNode = records[0];
                    mainProjectNode.set('sort_order','0');
                    me.setRootNode(mainProjectNode);
                }
            });

        },

        /*
         * The user has double-clicked on the row editor in order to
         * manually fill in the values. This procedure automatically
         * fills in the end_time.
         */
        onGridBeforeEdit: function(editor, context, eOpts) {
            console.log('GanttButtonController.onGridBeforeEdit');
            console.log(context.record);

            // Return true to indicate to the editor that it's OK to edit
            return true;
        },

        /**
         * Gets called after finishing an edit using the "Update" button
         */
        onGridEdit: function(editor, context) {
            console.log('GanttButtonController.onGridEdit');
            var rec = context.record;
            
            var interval_date = rec.get('interval_date');
            var interval_start = rec.get('interval_start');
            var interval_start_time = rec.get('interval_start_time');
            var interval_end = rec.get('interval_end');
            var interval_end_time = rec.get('interval_end_time');
            if ("" == interval_start_time) { interval_start_time = null; }
            if ("" == interval_end_time) { interval_end_time = null; }

            // start == end => Delete the entry
            if (interval_start_time != null && interval_end_time != null) {
                if (interval_start_time == interval_end_time) {
                    rec.destroy();
                    return;
                }
            }

            if (interval_date != null) {
                // The interval_date has been overwritten by the editor with a Date
                var value = new Date(interval_date);
                rec.set('interval_date', Ext.Date.format(value, 'Y-m-d'));
            }

            if (interval_date != null && interval_start_time != null) {
                var value = new Date(interval_date);
                value.setHours(interval_start_time.substring(0,2));
                value.setMinutes(interval_start_time.substring(3,5));
                rec.set('interval_start', Ext.Date.format(value, 'Y-m-d H:i:s'));
            }

            if (interval_date != null && interval_end_time != null) {
                var value = new Date(interval_date);
                value.setHours(interval_end_time.substring(0,2));
                value.setMinutes(interval_end_time.substring(3,5));
                rec.set('interval_end', Ext.Date.format(value, 'Y-m-d H:i:s'));
            }

            rec.save();
            rec.commit();

        },

        // Esc (Escape) button pressed somewhere in the application window
        onWindowKeyDown: function(e) {
            var keyCode = e.getKey();
            var keyCtrl = e.ctrlKey;
            console.log('GanttButtonController.onWindowKeyDown: code='+keyCode+', ctrl='+keyCtrl);
            
            // cancel hour logging with Esc key
            if (27 == keyCode) {
                // Cancel Edit
            }
            if (46 == keyCode) { this.onButtonDeleteEntry(); }
        },

        // Click into the empty space below the grid entries in order to start creating a new entry
        onGridContainerClick: function() {
            console.log('GanttButtonController.GridContainerClick');
            var buttonStartLogging = Ext.getCmp('buttonStartLogging');
            var disabled = buttonStartLogging.disabled;
            if (!disabled) {
                this.onButtonStartLogging();
            }
        },

        /*
         * Start logging the time.
         * Before calling this procedure, the user must have selected a single
         * leaf in the task tree for logging hours.
         */
        onButtonStartLogging: function() {
            console.log('GanttButtonController.ButtonStartLogging');

        },

        /*
         * Start logging the time, for entirely manual entries.
         */
        onButtonAddEntry: function() {
            console.log('GanttButtonController.ButtonManualLogging');

            var buttonAddEntry = Ext.getCmp('buttonAddEntry');
            var buttonDeleteEntry = Ext.getCmp('buttonDeleteEntry');
            // buttonAddEntry.disable();
            // buttonDeleteEntry.enable();
            rowEditing.cancelEdit();

            var day = PO.Utilities.dateToPg(new Date());
            var hour = new Ext.create('PO.model.timesheet.Hour', {
                user_id: @current_user_id@,
                day: day
            });

            hourStore.add(hour);
            rowEditing.startEdit(hour, 0);
        },

        onButtonDeleteEntry: function() {
            var me = this;
            console.log('GanttButtonController.ButtonDeleteLogging');

            var buttonAddEntry = Ext.getCmp('buttonAddEntry');
            // var buttonDeleteEntry = Ext.getCmp('buttonDeleteEntry');
            buttonAddEntry.enable();
            // buttonDeleteEntry.enable();
            rowEditing.cancelEdit();

            var records = hourGrid.getSelectionModel().getSelection();
            // Not logging already - enable the "start" button
            if (1 == records.length) {                  // Exactly one record enabled
                var record = records[0];
                hourStore.remove(record);
                record.destroy();
            }	    
        },

        /**
         * Control the enabled/disabled status of the Start/Stop logging buttons.
         * Skip logging hours when changing the selection.
         */
        onTreePanelSelectionChange: function(view, records) {
            if (this.debug) { console.log('GanttButtonController.onTreePanelSelectionChange'); }

            var buttonStartLogging = Ext.getCmp('buttonStartLogging');
            var buttonAddEntry = Ext.getCmp('buttonAddEntry');
            // Not logging already - enable the "start" button
            if (1 == records.length) {					// Exactly one record enabled

            } else {							// Zero or two or more records enabled
                buttonStartLogging.setDisabled(true);
                buttonAddEntry.setDisabled(true);
            }                
        },

        /**
         * Clicking around in the grid part of the screen,
         * Enable or disable the "Delete" button
         */
        onGridSelectionChange: function(view, records) {
            if (this.debug) { console.log('GanttButtonController.onGridSelectionChange'); }
            var buttonDeleteEntry = Ext.getCmp('buttonDeleteEntry');
            buttonDeleteEntry.setDisabled(1 != records.length);
        },


        /**
         * Handle various key actions
         */
        onCellKeyDown: function(table, htmlTd, cellIndex, record, htmlTr, rowIndex, e, eOpts) {
            console.log('GanttButtonController.onCellKeyDown');
            var keyCode = e.getKey();
            var keyCtrl = e.ctrlKey;
            console.log('GanttButtonController.onCellKeyDown: code='+keyCode+', ctrl='+keyCtrl);
        },


        /**
         * The windows as a whole was resized
         */
        onWindowsResize: function(width, height) {
            console.log('GanttButtonController.onWindowResize');
            var me = this;
            var sideBar = Ext.get('sidebar');				// ]po[ left side bar component
            var sideBarSize = sideBar.getSize();
            me.onResize(sideBarSize.width);
        },

        /**
         * The ]po[ left sideBar was resized
         */
        onSideBarResize: function(event, el, config) {
            console.log('GanttButtonController.onSideBarResize');
            var me = this;
            var sideBar = Ext.get('sidebar');				// ]po[ left side bar component
            var sideBarSize = sideBar.getSize();

            // We get the event _before_ the sideBar has changed it's size.
            // So we actually need to the the oposite of the sidebar size:
            if (sideBarSize.width > 100) {
                sideBarSize.width = -5;
            } else {
                sideBarSize.width = 245;
            }

            me.onResize(sideBarSize.width);
        },

        /**
         * Generic resizing function, called with the target width of the sideBar
         */
        onResize: function(sideBarWidth) {
            console.log('GanttButtonController.onResize: '+sideBarWidth);
            var me = this;
            var screenSize = Ext.getBody().getViewSize();
            var height = me.hourButtonPanel.getSize().height;
            var width = screenSize.width - sideBarWidth - 75;
            me.hourButtonPanel.setSize(width, height);
        }
        
    });


    var sideBarTab = Ext.get('sideBarTab');
    var hourController = Ext.create('PO.controller.timesheet.HourWeeklyController', {
        'hourButtonPanel': hourButtonPanel,
        'hourController': hourController,
        'hourGrid': hourGrid
    });
    hourController.init(this).onLaunch(this);
    hourGrid.hourController = hourController;   // Add reference to hourGrid
    
    // Testing events
    hourButtonPanel.fireEvent('keypress');

    // -----------------------------------------------------------------------
    // Handle collapsable side menu
    sideBarTab.on('click', hourController.onSideBarResize, hourController);
    Ext.EventManager.onWindowResize(hourController.onWindowsResize, hourController);    // Deal with resizing the main window
};


var debugHash = @debug_json;noquote@;
function getDebug(id) {
    // Check for a debug setting for the specific Id
    var debug = parseInt(debugHash[id]);
    if (!isNaN(debug)) return debug;

    // Use the default debug
    debug = parseInt(debugHash['default']);
    if (!isNaN(debug)) return debug;

    // invalid configuration - enable debug
    return 1;
};

// -----------------------------------------------------------------------
// Start the application after loading the necessary stores
//
Ext.onReady(function() {
    Ext.QuickTips.init();
    var debug = getDebug('default');
    var taskTreeStore = Ext.create('PO.store.timesheet.TaskTreeStore');
    var hourStore = Ext.create('PO.store.timesheet.HourStore');
    var projectStore = Ext.create('PO.store.project.ProjectMainStore');

    // Use a "store coodinator" in order to launchTimesheetWeeklyLogging() only
    // if all stores have been loaded:
    var coordinator = Ext.create('PO.controller.StoreLoadCoordinator', {
        stores: [
            'hourStore', 
            'taskTreeStore',
            'projectMainStore'
        ],
        listeners: {
            load: function() {
                if ("boolean" == typeof this.loadedP) { return; }
                launchTimesheetWeeklyLogging();
                this.loadedP = true;
            }
        }
    });

    // Load stores that need parameters
    taskTreeStore.getProxy().extraParams = { project_id: @project_id@ };
    taskTreeStore.load({
        callback: function(records, operation, success) {
            var me = this;
            if (debug) console.log('PO.store.timesheet.TaskTreeStore: loaded');
            if (!success) {
                PO.Utilities.reportStoreError("TaskTreeStore", operation);
                return;
            }
            var mainProjectNode = records[0];
            mainProjectNode.set('sort_order','0');
            me.setRootNode(mainProjectNode);
        }
    });

    // Load stores that need parameters
    hourStore.getProxy().extraParams = { user_id: @current_user_id@, format: 'json' };
    hourStore.load({
        callback: function() {
            console.log('PO.store.timesheet.HourStore: loaded');
        }
    });

    // Load stores that need parameters
    // projectStore.getProxy().extraParams = { query: 'parent_id is NULL and project_status_id = 76', format: 'json' };
    projectStore.getProxy().extraParams = { query: 'parent_id is NULL and project_status_id in (select * from im_sub_categories(76))', format: 'json' };
    projectStore.load({
        callback: function() {
            console.log('PO.store.project.ProjectMainStore: loaded');
        }
    });
});
</script>
</div>


